Imports System.Runtime.InteropServices
Imports System.Threading
Imports System.Drawing.Imaging
Public Class Form1
    Const WS_CHILD As Long = &H40000000
    Const WS_VISIBLE As Long = &H10000000
    Const WM_USER As Long = &H400
    Const WM_CAP_START As Long = WM_USER
    Const WM_CAP_DRIVER_CONNECT As Long = WM_CAP_START + 10
    Const WM_CAP_DRIVER_DISCONNECT As Long = WM_CAP_START + 11
    Const WM_CAP_SET_PREVIEW As Long = WM_CAP_START + 50
    Const WM_CAP_SET_PREVIEWRATE As Long = WM_CAP_START + 52
    Const WM_CAP_DLG_VIDEOFORMAT As Long = WM_CAP_START + 41
    Const WM_CAP_FILE_SAVEDIB As Long = WM_CAP_START + 25
    Const WM_CAP_SEQUENCE = WM_CAP_START + 62
    Const WM_CAP_FILE_SAVEAS = WM_CAP_START + 23

    Const WM_CAP_DLG_VIDEOCOMPRESSION As Long = 1070
    'Const WM_CAP_DLG_VIDEOFORMAT As Long = 1065
    Const WM_CAP_DLG_VIDEOSOURCE As Long = 1066
    'Const WM_CAP_DRIVER_CONNECT As Long = 1034
    'Const WM_CAP_DRIVER_DISCONNECT As Long = 1035
    Const WM_CAP_EDIT_COPY As Long = 1054
    Const WM_CAP_GRAB_FRAME As Long = 1084
    Const WM_CLOSE As Long = 16

    Const Head As String = "Video Surveillance"


    Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
        (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, _
        <MarshalAs(UnmanagedType.AsAny)> ByVal lParam As Object) As Integer

    Declare Function capCreateCaptureWindowA Lib "avicap32.dll" _
        (ByVal lpszWindowName As String, ByVal dwStyle As Integer, _
        ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, _
        ByVal nHeight As Short, ByVal hWndParent As Integer, _
        ByVal nID As Integer) As Integer

    Declare Function capGetDriverDescriptionA Lib "avicap32.dll" (ByVal wDriver As Short, _
        ByVal lpszName As String, ByVal cbName As Integer, ByVal lpszVer As String, _
        ByVal cbVer As Integer) As Boolean


    'The variables used by this program:
    Dim data As IDataObject
    Dim bmap As Bitmap
    Dim dw As Integer = 128 ' 64 '128
    Dim dh As Integer = 96 ' 48 '96
    Dim bmapcap As New Bitmap(dw, dh)

    Dim iDevice As Integer = 0 ' Current device ID
    Dim hHwnd As Integer ' Handle to preview window

    Dim BMP1 As Bitmap
    Dim BMP2 As Bitmap
    Dim BMP3 As Bitmap
    Dim color1 As Color
    Dim color2 As Color
    Dim DifRed As Long, DifGreen As Long, DifBlue As Long
    Dim Thres As Long
    Dim Pixelcount As Long
    Dim X As Integer, Y As Integer, K As Integer
    Dim strName As String = Space(100)
    Dim strVer As String = Space(100)
    Dim Restart As Boolean
    Dim Startnow As Integer
    Dim lastsend As Date
    Dim trd As Thread
    Dim msg As String
    Dim i As Integer
    Dim pix As Integer

    Dim SnapShotFile As String

    Const BYTE_255 As Byte = 255
    Public RowSizeBytes1 As Integer
    Public PixBytes1() As Byte
    Public RowSizeBytes2 As Integer
    Public PixBytes2() As Byte
    Public RowSizeBytes3 As Integer
    Public PixBytes3() As Byte
    Private BitmapData1 As BitmapData
    Private BitmapData2 As BitmapData
    Private BitmapData3 As BitmapData
    Private Sub LoadDeviceList()
        Dim bReturn As Boolean
        X = 0
        Do
            bReturn = capGetDriverDescriptionA(X, strName, 100, strVer, 100)
            If bReturn = True Then
                mnu_camera.DropDownItems.Add(strName.ToString)
                bReturn = False
            Else
                X += 1
            End If
        Loop Until bReturn = False
    End Sub
    Private Sub CompareImage2()
        BMP1 = Picture2.Image
        BMP2 = picCapture.Image
        BMP3 = Pictureout.Image
        Dim bounds As Rectangle = New Rectangle(0, 0, BMP1.Width, BMP1.Height)
        'Dim widthratio As Integer
        'Dim heightratio As Integer
        'Dim iwidth As Integer
        'Dim iheight As Integer
        'Dim colm As Integer, row As Integer
        'Dim eleColm As Integer, elerow As Integer
        'Dim clrValue As Integer
        'Dim cnt As Integer
        'Dim selrow As Integer
        'Dim selcol As Integer



        BitmapData1 = BMP1.LockBits(bounds, Imaging.ImageLockMode.ReadWrite, Imaging.PixelFormat.Format24bppRgb)
        BitmapData2 = BMP2.LockBits(bounds, Imaging.ImageLockMode.ReadWrite, Imaging.PixelFormat.Format24bppRgb)
        BitmapData3 = BMP3.LockBits(bounds, Imaging.ImageLockMode.ReadWrite, Imaging.PixelFormat.Format24bppRgb)

        RowSizeBytes1 = BitmapData1.Stride
        RowSizeBytes2 = BitmapData2.Stride
        RowSizeBytes3 = BitmapData3.Stride
        Pixelcount = BitmapData1.Width * BitmapData1.Height

        Dim total_size As Integer = BitmapData1.Stride * BitmapData1.Height
        ReDim PixBytes1(total_size)
        ReDim PixBytes2(total_size)
        ReDim PixBytes3(total_size)

        Marshal.Copy(BitmapData1.Scan0, PixBytes1, 0, total_size)
        Marshal.Copy(BitmapData2.Scan0, PixBytes2, 0, total_size)
        Marshal.Copy(BitmapData3.Scan0, PixBytes3, 0, total_size)
        pix = 0

        For Y = 0 To total_size - 3 Step 3
            DifRed = Math.Abs(CLng(PixBytes1(Y)) - CLng(PixBytes2(Y)))
            DifGreen = Math.Abs(CLng(PixBytes1(Y + 1)) - CLng(PixBytes2(Y + 1)))
            DifBlue = Math.Abs(CLng(PixBytes1(Y + 2)) - CLng(PixBytes2(Y + 2)))
            If DifRed > Thres Or DifGreen > Thres Or DifBlue > Thres Then
                PixBytes3(Y) = 0
                PixBytes3(Y + 1) = 0
                PixBytes3(Y + 2) = 255
            Else
                PixBytes3(Y) = 0
                PixBytes3(Y + 1) = 0
                PixBytes3(Y + 2) = 0
            End If
        Next

        Marshal.Copy(PixBytes3, 0, BitmapData3.Scan0, total_size)
        BMP1.UnlockBits(BitmapData1)
        BMP2.UnlockBits(BitmapData2)
        BMP3.UnlockBits(BitmapData3)
        Pictureout.Image = BMP3
        PictureBox1.Image = Pictureout.Image
        If Form3.Visible = True Then
            Dim ix As Integer
            Dim iy As Integer
            Dim bx As Integer
            Dim by As Integer
            Dim bw As Integer
            Dim bh As Integer
            Dim pixvalue As Integer
            Dim pixnum As Integer
            Dim bmpc As New Bitmap(Form3.PictureBox1.Width, Form3.PictureBox1.Height, PixelFormat.Format32bppArgb)
            Dim pen1 As New System.Drawing.Pen(Color.Green, 4)
            Dim redBrush As Brush = New SolidBrush(Color.Red)
            Dim grayBrush As Brush = New SolidBrush(Color.Gray)
            Dim g As Graphics = Graphics.FromImage(bmpc)
            bw = ((Form3.PictureBox1.Width / dw) / 3) * 2
            bh = ((Form3.PictureBox1.Height / dh) / 3) * 2

            If bw > bh Then
                bh = bw
            Else
                bw = bh
            End If

            For iy = 1 To dh
                ix = 0
                For ix = 1 To dw
                    bx = (Form3.PictureBox1.Width / dw) * (ix - 1)
                    by = (Form3.PictureBox1.Height / dh) * (iy - 1)
                    pixnum = ((iy - 1) * (dw * 3)) + ((ix - 1) * 3)
                    pixvalue = PixBytes3(pixnum + 2)
                    If pixvalue = 255 Then
                        ' g.DrawEllipse(Pens.Red, bx, by, bw, bh)
                        g.FillEllipse(redBrush, bx, by, bw, bh)
                        'g.FillRectangle(redBrush, bx, by, bw, bh)
                    Else
                        'g.DrawEllipse(Pens.Gray, bx, by, bw, bh)
                        g.FillEllipse(grayBrush, bx, by, bw, bh)
                        'g.FillRectangle(grayBrush, bx, by, bw, bh)
                    End If
                Next
            Next
            Form3.PictureBox1.Image = bmpc
            g.Dispose()
        End If
    End Sub
    Private Sub Grabsingleframe()
        SendMessage(hHwnd, WM_CAP_GRAB_FRAME, CLng(0), CLng(0))
        SendMessage(hHwnd, WM_CAP_EDIT_COPY, CLng(0), CLng(0))
        data = Clipboard.GetDataObject()
        If data.GetDataPresent(GetType(System.Drawing.Bitmap)) Then
            bmap = CType(data.GetData(GetType(System.Drawing.Bitmap)), Image)
            Dim gr_dest As Graphics = Graphics.FromImage(bmapcap)
            gr_dest.DrawImage(bmap, 0, 0, dw, dh)
            picCapture.Image = DirectCast(bmapcap.Clone, Bitmap)
            'Picture2.Image = picCapture.Image
            'Pictureout.Image = picCapture.Image
            Picture2.Image = DirectCast(picCapture.Image.Clone, Bitmap)
            Pictureout.Image = DirectCast(picCapture.Image.Clone, Bitmap)
        End If
    End Sub
    Private Sub GrabFrame()
        Do Until Restart = False
            Application.DoEvents()
            SendMessage(hHwnd, WM_CAP_GRAB_FRAME, CLng(0), CLng(0))
            SendMessage(hHwnd, WM_CAP_EDIT_COPY, CLng(0), CLng(0))
            data = Clipboard.GetDataObject()
            If data.GetDataPresent(GetType(System.Drawing.Bitmap)) Then
                bmap = CType(data.GetData(GetType(System.Drawing.Bitmap)), Image)
                If Form2.Visible = True Then
                    Form2.PictureBox1.Image = bmap
                End If
                Dim gr_dest As Graphics = Graphics.FromImage(bmapcap)
                gr_dest.DrawImage(bmap, 0, 0, dw, dh)
                picCapture.Image = DirectCast(bmapcap.Clone, Bitmap)

                'picCapture.Image = DirectCast(bmap.Clone, Bitmap)

                If Startnow > 1 Then
                    CompareImage2()
                Else
                    Startnow = 2
                End If
            End If
        Loop
    End Sub
    Private Sub OpenPreviewWindow()
        hHwnd = capCreateCaptureWindowA(iDevice, CLng(0), CLng(0), CLng(0), CLng(0), CLng(0), CLng(0), CLng(0))
        If SendMessage(hHwnd, WM_CAP_DRIVER_CONNECT, iDevice, 0) Then
            SendMessage(hHwnd, WM_CAP_DRIVER_CONNECT, CLng(0), CLng(0))

            Grabsingleframe()
            Restart = False
        Else
            MsgBox("Error Connecting to the specific device", MsgBoxStyle.Information, Head)
        End If
    End Sub
    Private Sub ClosePreviewWindow()
        SendMessage(hHwnd, WM_CAP_DRIVER_DISCONNECT, iDevice, 0)
    End Sub
    Private Sub VideoSur_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If StartToolStripMenuItem.Enabled = False Then
            e.Cancel = True
        End If
    End Sub
    Private Sub VideoSur_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For i = 1 To 100
            ToolStripComboBox1.Items.Add(i)
        Next
        picCapture.Width = dw
        picCapture.Height = dh
        Picture2.Width = dw
        Picture2.Height = dh
        Pictureout.Width = dw
        Pictureout.Height = dh
        ToolStripComboBox1.SelectedIndex = 14
        Thres = Int(ToolStripComboBox1.Text) * 2.55
        Picture2.Visible = True
        Pictureout.Visible = True
        StartToolStripMenuItem.Enabled = True
        StopToolStripMenuItem.Enabled = False
        LoadDeviceList()
        If strName.Trim <> "" Then
            iDevice = 0
            OpenPreviewWindow()
        Else
            MsgBox("No Proper Camera Found", MsgBoxStyle.Information, Head)
            End
        End If
    End Sub
    Private Sub picCapture_SizeChanged1(ByVal sender As Object, ByVal e As System.EventArgs) Handles picCapture.SizeChanged

        Picture2.Width = picCapture.Width
        Picture2.Height = picCapture.Height

        Pictureout.Width = picCapture.Width
        Pictureout.Height = picCapture.Height
    End Sub
    Private Sub StartToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartToolStripMenuItem.Click
        If SendMessage(hHwnd, WM_CAP_DRIVER_CONNECT, iDevice, 0) = False Then
            MsgBox("Error in capture")
        End If
        StartToolStripMenuItem.Enabled = False
        StopToolStripMenuItem.Enabled = True
        Restart = True
        Startnow = 1
        GrabFrame()
    End Sub
    Private Sub StopToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StopToolStripMenuItem.Click
        Try
            SendMessage(hHwnd, WM_CAP_DRIVER_DISCONNECT, iDevice, 0)
        Catch ex As Exception

        End Try
        Restart = False
        StartToolStripMenuItem.Enabled = True
        StopToolStripMenuItem.Enabled = False
    End Sub
    Private Sub ToolStripComboBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripComboBox1.SelectedIndexChanged
        Thres = Int(ToolStripComboBox1.Text) * 2.55
    End Sub
    Private Sub SetBackgroundToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetBackgroundToolStripMenuItem.Click
        Picture2.Image = DirectCast(picCapture.Image.Clone, Bitmap)
    End Sub
    Private Sub Pictureout_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Pictureout.DoubleClick
        If Form2.Visible = True Then
            Form2.Close()
            Form3.Close()
        Else
            Form2.Show()
            Form3.Show()
        End If
    End Sub

    Private Sub Picture2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Picture2.Click

    End Sub

    Private Sub Pictureout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Pictureout.Click

    End Sub
End Class
